LIBRARY IEEE;
USE IEEE.STD_LOGIC_1164.ALL;

ENTITY multi IS
	PORT(CLK_MST: IN STD_LOGIC;
           Q1, Q2, Q3, Q4: IN INTEGER RANGE 0 TO 9; -- # entradas
			     Y: OUT STD_LOGIC_VECTOR (7 DOWNTO 0); 
			     S: OUT STD_LOGIC_VECTOR(3 DOWNTO 0)); -- # de displays
END ENTITY;

ARCHITECTURE BEAS OF multi IS
SIGNAL X: INTEGER RANGE 0 TO 3;
SIGNAL BIN: INTEGER RANGE 0 TO 10;
SIGNAL AUX: INTEGER RANGE 0 TO 2499;
SIGNAL CLK: STD_LOGIC;

BEGIN
		PROCESS(CLK_MST) -- 1000 Hz
		BEGIN 
		IF RISING_EDGE (CLK_MST) THEN
			IF AUX = 0 THEN  -- IF AUX = FREC THEN
				CLK <= NOT CLK;
				AUX <= 2499; -- AUX <= 0;
			ELSE
				AUX <= AUX - 1; -- AUX <= AUX + 1;
			END IF;
		END IF;
	END PROCESS;


	PROCESS(CLK)
	BEGIN
		IF RISING_EDGE (CLK) THEN
			X <= X + 1;
		END IF;
	END PROCESS;
			  
	PROCESS(X)
		BEGIN
			CASE X IS
				WHEN 0 => BIN <= Q1;
				WHEN 1 => BIN <= Q2;
				WHEN 2 => BIN <= Q3;
				WHEN 3 => BIN <= Q4;
				WHEN OTHERS => BIN <= 10;
			END CASE;
	END PROCESS;
	
	WITH X SELECT
		S <= "1110" WHEN 0,
			  "1101" WHEN 1,
			  "1011" WHEN 2,
			  "0111" WHEN 3,
			  "1111" WHEN OTHERS;
	
	WITH BIN SELECT
	Y<="00000011" WHEN 0, -- 0
	   "10011111" WHEN 1, -- 1
	   "00100101" WHEN 2, -- 2
	   "00001101" WHEN 3, -- 3
	   "10011001" WHEN 4, -- 4
	   "01001001" WHEN 5, -- 5
	   "01000001" WHEN 6, -- 6
	   "00011111" WHEN 7, -- 7
	   "00000001" WHEN 8, -- 8
	   "00001001" WHEN 9, -- 9
	   "11111111" WHEN OTHERS;
			  
END BEAS;